#if !defined(AFX_CRC32_H__8DFA65B2_B0AC_11D2_8FBD_000000000000__INCLUDED_)
#define AFX_CRC32_H__8DFA65B2_B0AC_11D2_8FBD_000000000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Crc32.h : header file
//

typedef	union 
{ 
    WORD w;
	struct 
	{
       WORD b0  :1;  // lsb
       WORD b1  :1;
       WORD b2  :1;
       WORD b3  :1;
       WORD b4  :1;
       WORD b5  :1;
       WORD b6  :1;
       WORD b7  :1;  // msb
       WORD unused :8;  
	} bit;
} bit16;

typedef	union 
{    
	DWORD  dw;
    struct 
	{
        WORD b0  :1;  // lsb
		WORD b1  :1;
        WORD b2  :1;
        WORD b3  :1;
        WORD b4  :1;
        WORD b5  :1;
        WORD b6  :1;
        WORD b7  :1;
        WORD b8  :1;
        WORD b9  :1;
        WORD b10 :1;
        WORD b11 :1;
        WORD b12 :1;
        WORD b13 :1;
        WORD b14 :1;
        WORD b15 :1;
        WORD b16 :1;
        WORD b17 :1;
        WORD b18 :1;
        WORD b19 :1;
        WORD b20 :1;
        WORD b21 :1;
        WORD b22 :1;
        WORD b23 :1;
        WORD b24 :1;
        WORD b25 :1;
        WORD b26 :1;
        WORD b27 :1;
        WORD b28 :1;
        WORD b29 :1;
        WORD b30 :1;
        WORD b31 :1; 
	} bit;
} bit32;

const int GOOD_CRC32_RESIDUAL = 0xDEBB20E3L;

/////////////////////////////////////////////////////////////////////////////
// CCrc32 

class CCrc32
{
public:
	CCrc32();
	virtual ~CCrc32();

    void GenerateTable();
    DWORD GetCRC( const unsigned char * pTextPtr, int nLength, DWORD dwInitialCrc = 0 ) const;

protected:
    DWORD m_crcTable[256];
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CRC32_H__8DFA65B2_B0AC_11D2_8FBD_000000000000__INCLUDED_)
